# This code is copyrighted by Stephan Richter in August, 2000.
#
# written by Stephan Richter
# Last updated: March 18, 2001

from Products.DBObjects import DBObjectFolder, DBObject, DBTable, DBAttribute 


class Choice(DBObject):
    '''Choice class -  contains/manages data associated with a Choice'''

    meta_type = 'Choice'
    icon = 'misc_/ZQuest/choice'

    useUndo   = 0

    dbTable = ( DBTable('Choice', [],
                        {'value'           : DBAttribute('value',           'text'),
                         'iscorrectchoice' : DBAttribute('iscorrectchoice', 'boolean')})
                + DBObject.dbTable )



class ChoiceFolder(DBObjectFolder):
    '''ChoiceFolder class - contains all Choices for one project.'''

    meta_type = 'ChoiceFolder'  
    icon = 'misc_/ZQuest/choiceFolder'

    useUndo   = 0
    
    allowedSubObjects = ('Choice',)
