# This code is copyrighted by Stephan Richter in August, 2000.
#
# written by Stephan Richter
# Last updated: March 18, 2001

from Products.DBObjects import DBObjectFolder, DBObject, DBTable, DBAttribute 

import PIL
import rexec, cStringIO
import re, os, string, urllib, sys
from math import *


class DisplayObject(DBObject):
    '''DisplayObject class -  contains/manages data associated with a DisplayObject'''

    meta_type = 'DisplayObject'
    icon = None

    useUndo   = 0

    dbTable = ( DBTable('DisplayObject', [],
                        {'name'      : DBAttribute('name',      'varchar(50)'),
                         'width'     : DBAttribute('width',     'varchar(50)'),
                         'height'    : DBAttribute('height',    'varchar(50)')})
                + DBObject.dbTable )

    titleDBRepresentation = 'name'


    def __call__(self, REQUEST=None):
        if REQUEST:
            return self.getHTMLRepresentation(REQUEST)
        else:
            return self
        

    def getHTMLRepresentation(REQUEST):
        '''getHTMLRepresentation(REQUEST) --> returns the HTML code representating the object; return string'''

        return ''


    def manage_view(self, RESPONSE):
        '''manage_view(self, RESPONSE) --> return image bit stream; '''

        return None



class DisplayObjectFolder(DBObjectFolder):
    '''DisplayObjectFolder class - contains all DisplayObjects for one project.'''

    meta_type = 'DisplayObjectFolder'  
    icon = 'misc_/ZQuest/variableFolder'

    useUndo   = 0
    
    allowedSubObjects = ('ZQuestGraph', 'ZQuestImage', 'ZQuestLatex')



