# This code is copyrighted by Stephan Richter in August, 2000.
#
# written by Stephan Richter
# Last updated: March 18, 2001

from Products.DBObjects import DBObjectFolder, DBObject, DBTable, DBAttribute
import Tools


class GivenVariable(DBObject):
    '''GivenVariable class -  contains/manages data associated with a GivenVariable'''

    meta_type = 'GivenVariable'
    icon = 'misc_/ZQuest/variable'

    useUndo   = 0

    dbTable = ( DBTable('GivenVariable', [],
                        {'variablename'       : DBAttribute('variablename',       'varchar(100)'),
                         'minvalue'           : DBAttribute('minvalue',           'float', 'float'),
                         'maxvalue'           : DBAttribute('maxvalue',           'float', 'float'),
                         'significantfigures' : DBAttribute('significantfigures', 'int', 'int'),
                         'units'              : DBAttribute('units',              'varchar(20)')})
                + DBObject.dbTable )

    titleDBRepresentation = 'variablename'


    def getRandomValue(self):
        '''getRandomValue(self) --> get a random number between minvalue and maxvalue; return float'''

        attributes = self.getAttributes()[0]
        return Tools.createRandomNumber(attributes.minvalue, attributes.maxvalue)



class GivenVariableFolder(DBObjectFolder):
    '''GivenVariableFolder class - contains all GivenVariables for one NumericProblem.'''

    meta_type = 'GivenVariableFolder'  
    icon = 'misc_/ZQuest/variableFolder'

    useUndo   = 0
    
    allowedSubObjects = ('GivenVariable',)
