# This code is copyrighted by Stephan Richter in September, 2001.
#
# written by Stephan Richter
# Last updated: September 2, 2001

from OFS.DTMLMethod     import addDTMLMethod
from Products.DBObjects import ZopeFolder

class HomepageFolder(ZopeFolder):
    '''A DBObject API compliant ZODB Folder.'''

    meta_type = 'HomepageFolder'  
    
    manageRoles = ('ManageHomepageFolders', 'ManageHomepageFolder%(homepagefolderid)s',)
    viewRoles   = ('ViewHomepageFolders', 'ViewHomepageFolder%(homepagefolderid)s')

    __ac_permissions__=(
        ('View management screens', ('manage_main',) ),
        ('Add DBObjects',           ('hasManagePermission',) ),
        ('Edit DBObjects',          ('hasManagePermission',) ),
        ('Delete DBObjects',        ('deleteDBAttributes', 'hasManagePermission')),
        ('View DBObjects',          ('getAttributes', 'hasViewPermission') ),
        )

    def __init__(self, parent, id, title):
        ''' API compliant __init__ method'''
        self.id = id
        addDTMLMethod(self, 'index_html', 'Main Page', _index_html)
        


_index_html = '''
<dtml-var physicsHeader>
  <br>
  <dtml-with "Classes[getClassId()].getAttributes()[0]">
    <center>
      <h1>Welcome to <dtml-var name> (<dtml-var coursenumber>)</h1>
      <dtml-with "acl_users.getPersonById(instructorid)[0]">
        Instructor: Dr. <dtml-var fname> <dtml-var lname>
      </dtml-with>
      <hr width="90%" size="1">
    </center>
    <p><b>Course Description</b>: <dtml-var description missing></p>

    <p>The professor can add course-specifc content here.</p>
  </dtml-with>
<dtml-var physicsFooter>
'''
