# This code is copyrighted by Stephan Richter in August, 2000.
#
# written by Stephan Richter
# Last updated: March 18, 2001

from Problem            import Problem
from Products.DBObjects import DBTable, DBAttribute 


class MatchProblem(Problem):
    '''MatchProblem class -  contains/manages data associated with a Problem'''

    meta_type = 'MatchProblem'

    dbTable = DBTable('MatchProblem', ['Problem'])

    allowedSubObjects = ('MatchPairFolder', 'DisplayObjectFolder', 'GivenVariableFolder')


    def getScoreForAnswer(self, REQUEST):
        '''getScoreForAnswer(self, REQUEST) --> returns the score achieved and max score of the problem;
           return (score, maxscore)'''

        maxscore = float(self.getAttributes()[0].maxscore)
        results = self.MatchPairs.getResultsFromRequest(REQUEST)

        score = (results/len(self.MatchPairs.objectIds()))*maxscore
        
        return (score, maxscore)
