# This code is copyrighted by Stephan Richter in August, 2000.
#
# written by Stephan Richter
# Last updated: March 18, 2001

from Products.DBObjects import DBObjectFolder, DBObject, DBTable, DBAttribute 


class Score(DBObject):
    '''Score class -  contains/manages data associated with a Score'''

    meta_type = 'Score'
    icon = 'misc_/ZQuest/score'

    useUndo   = 0

    dbTable = ( DBTable('Score', [],
                        {'classproblemsetid' : DBAttribute('classproblemsetid', 'int', 'int'),
                         'score'             : DBAttribute('score',             'float', 'float' ),
                         'takendatetime'     : DBAttribute('takendatetime',     'datetime' )} )
                + DBObject.dbTable )

    titleDBRepresentation = None



_qry_getMaxScoreOfProblemSet = '''
SELECT max(score)
  FROM Score
  WHERE
    containerid = <dtml-sqlvar personid type="int"> AND
    <dtml-sqltest classproblemsetid type="int">
'''


class ScoreFolder(DBObjectFolder):
    '''ScoreFolder class - contains all Scores for one project.'''

    meta_type = 'ScoreFolder'  
    icon = 'misc_/ZQuest/scoreFolder'

    useUndo   = 0
    
    allowedSubObjects = ('Score',)

    sqlMethods = ( ('qry_getMaxScoreOfProblemSet', 'personid=0 classproblemsetid=0', _qry_getMaxScoreOfProblemSet), )


    def getMaxScoreOfProblemSet(self, classProblemSetId):
        '''getMaxScoreOfProblemSet(self, classProblemSetId) --> Returns the highest score for a certain
           Class Problem Set; return int'''

        container = self._getSQLMethodContainer(self)
        return container.qry_getMaxScoreOfProblemSet(personid=self.getPersonId(), classproblemsetid=classProblemSetId)
