# This code is copyrighted by Stephan Richter in August, 2000.
#
# written by Stephan Richter
# Last updated: March 18, 2001

from Products.DBObjects import DBObjectFolder, DBObject, DBTable, DBAttribute 


class SearchedVariable(DBObject):
    '''SearchedVariable class -  contains/manages data associated with a SearchedVariable'''

    meta_type = 'SearchedVariable'
    icon = 'misc_/ZQuest/variable'

    useUndo   = 0

    dbTable = ( DBTable('SearchedVariable', [],
                        {'variablename'         : DBAttribute('variablename',         'varchar(100)'  ),
                         'units'                : DBAttribute('units',                'varchar(20)'  ),
                         'errortolerancefactor' : DBAttribute('errortolerancefactor', 'float', 'float'),
                         'evalfunction'         : DBAttribute('evalfunction',         'text')})
                + DBObject.dbTable )


    titleDBRepresentation = 'variablename'



class SearchedVariableFolder(DBObjectFolder):
    '''SearchedVariableFolder class - contains all SearchedVariables for one NumericProblem.'''

    meta_type = 'SearchedVariableFolder'  
    icon = 'misc_/ZQuest/variableFolder'

    useUndo   = 0
    
    allowedSubObjects = ('SearchedVariable',)
    
