# This code is copyrighted by Stephan Richter in August, 2000.
#
# written by Stephan Richter
# Last updated: March 18, 2001

from Products.DBObjects import DBObjectFolder, DBObject, DBTable, DBAttribute 


class SessionVariable(DBObject):
    '''SessionVariable class -  contains/manages data associated with a SessionVariable'''

    meta_type = 'SessionVariable'
    icon = 'misc_/ZQuest/variable'

    useUndo   = 0

    dbTable = ( DBTable('SessionVariable', [],
                      {'variablename'     : DBAttribute('variablename',     'varchar(50)'),
                       'textvalue'        : DBAttribute('textvalue',        'text'),
                       'numericvalue'     : DBAttribute('numericvalue',     'float', 'float')})
                + DBObject.dbTable )

    titleDBRepresentation = 'variablename'



class SessionVariableFolder(DBObjectFolder):
    '''SessionVariableFolder class - contains all SessionVariables for one project.'''

    meta_type = 'SessionVariableFolder'  
    icon = 'misc_/ZQuest/variableFolder'

    useUndo   = 0
    
    allowedSubObjects = ('SessionVariable',)
