import random, string, math


def randomizeList(list):
    '''randomizeList(list) --> make the order of elements in the list random; return list'''

    # setup some variables
    randElements = {}
    randNumber = random.randint(0, 100)

    # put the elements of the list in a dictionary with random keys 
    for element in list:
        while randNumber in randElements.keys():
            randNumber = random.randint(0, 100)
            
        randElements[randNumber] = element

    # get the random keys and sort them by size (makes the list random)
    randElementsKeys = randElements.keys()
    randElementsKeys.sort()

    # initialize the new list
    list = []

    # now construct the list using the random key
    for key in randElementsKeys:
        list.append(randElements[key])

    return list


def createRandomNumber(min, max):
    '''createRandomNumber(min, max) --> Create random number between min and max; return float'''
    diff = float(max-min)
    negativeOffset = float(-min)
    return (random.random()*diff)-negativeOffset


def getMagnitudeOfNumber(number):
    '''getMagnitudeOfNumber(number) --> Find the magnitude of a number; return int'''

    return int(round(math.log(abs(number))/math.log(10)-0.5))


def roundNumberToSigFig(number, sigFig):
    '''roundNumberToSigFig(number, sigFig) --> round the number by the correct significant figures;
       return float'''

    magnitude = getMagnitudeOfNumber(number)
    return round(number, -(magnitude-sigFig))
    

def replaceStarForRegExStar(text):
    '''replaceStarForRegExStar(text) --> make a legal regex string from the input text; return string'''
    regexText = ''
    try:
        regexText = string.replace(text, '*', '.*')
    except TypeError:
        regexText = ''

    return regexText
