# This code is copyrighted by Stephan Richter in August, 2000.
#
# written by Stephan Richter
# Last updated: March 18, 2001

from Problem            import Problem
from Products.DBObjects import DBTable, DBAttribute 


class TrueFalseProblem(Problem):
    '''TrueFalseProblem class -  contains/manages data associated with a Problem'''

    meta_type = 'TrueFalseProblem'

    dbTable = DBTable('TrueFalseProblem', ['Problem'],
                      {'correctanswer' : DBAttribute('correctanswer', 'boolean')})

    allowedSubObjects = ('DisplayObjectFolder', 'GivenVariableFolder')


    def getScoreForAnswer(self, REQUEST):
        '''getScoreForAnswer(self, REQUEST) --> returns the score achieved and max score of the problem;
           return (score, maxscore)'''

        attributes = self.getAttributes()[0]
        maxscore = float(attributes.maxscore)
        correctanswer = attributes.correctanswer

        if correctanswer == REQUEST['answer']:
            score = maxscore
        else:
            score = 0
        
        return (score, maxscore)
