# This code is copyrighted by Stephan Richter in August, 2000.
#
# written by Stephan Richter
# Last updated: March 18, 2001

from Products.DBObjects     import DBTable, DBAttribute 
from DisplayObject          import DisplayObject
from OFS.Image              import Image

import tempfile, os


class ZQuestLatex(DisplayObject, Image):
    '''contains/manages data associated with a ZQuestLatex'''

    meta_type = 'ZQuestLatex'
    icon = 'misc_/ZQuest/variable'

    manage_options = DisplayObject.manage_options + ({'label':'Upload Image',  'action':'manage_uploadForm'},
                                                     {'label':'View',          'action':''},)

    dbTable = DBTable('ZQuestLatex', ['DisplayObject'],
                      {'code'        : DBAttribute('code',        'text'          ),
                       'dpi'         : DBAttribute('dpi',         'int',   'int'  ),
                       'detailratio' : DBAttribute('detailratio', 'float', 'float'),
                       'margin'      : DBAttribute('margin',      'int',   'int'  )})


    manage_uploadForm = Image.manage_editForm


    def getHTMLRepresentation(self, REQUEST):
        '''getHTMLRepresentation(REQUEST) --> returns the HTML code representating the object; return string'''

        return self.tag()


    def generate(self):
        ''' '''
        filename = tempfile.mktemp()
        print filename
        attrs = self.getAttributes()[0]

        open(filename+'.tex', 'w').write(attrs.code)

        print (command %{'file'        : filename,
                         'workDPI'     : int(attrs.detailratio)*int(attrs.dpi),
                         'xSize'       : 12*int(attrs.detailratio)*int(attrs.dpi),
                         'ySize'       : 12*int(attrs.detailratio)*int(attrs.dpi),
                         'reductRatio' : 1.0/float(attrs.detailratio),
                         'margin'      : attrs.margin})

        os.system(command %{'file'        : filename,
                            'workDPI'     : int(attrs.detailratio)*int(attrs.dpi),
                            'xSize'       : 12*int(attrs.detailratio)*int(attrs.dpi),
                            'ySize'       : 12*int(attrs.detailratio)*int(attrs.dpi),
                            'reductRatio' : 1.0/float(attrs.detailratio),
                            'margin'      : attrs.margin})

        gif = open(filename+'.gif')
        self.manage_upload(gif)
        gif.close()
        os.system('rm '+filename+'.gif')



command = """
cd /var/tmp 
latex %(file)s.tex;

dvips -f %(file)s.dvi > %(file)s.ps;

gs -sDEVICE=ppmraw \
   -sOutputFile=- \
   -g%(xSize)sx%(ySize)s \
   -r%(workDPI)s \
   -q -dNOPAUSE %(file)s.ps < /dev/null  | \
pnmscale %(reductRatio).3f | \
pnmcrop -white | \
pnmmargin -white %(margin)s | \
ppmquant 256 | \
ppmtogif -interlace - \
> %(file)s.gif

rm -f %(file)s.log %(file)s.aux %(file)s.tex %(file)s.dvi %(file)s.ps
"""






