__doc__='''
ZQuest Development Version.

This product allows the user to generate online (automated) tests, quizzes
and homeworks.
'''

# DEBUG IMPORT STATEMENTS
import Choice, GivenVariable, SearchedVariable, Zope
import Class, ClassProblem, ClassProblemSet
import Problem, EssayProblem, TrueFalseProblem, MatchProblem, MultipleChoiceProblem, NumericProblem
import Session, SessionProblem, SessionVariable
import ZQuestGraph, ZQuestImage, ZQuestLatex

import ProblemSet, Class, Session, PersonGroup


def initialize(context):
    context.registerClass(
        ProblemSet.ProblemSetFolder, 
        constructors=(ProblemSet.manage_addProblemSetFolderForm,
                      ProblemSet.manage_addProblemSetFolder),
        icon='www/problemSetFolder.gif',
        )

    context.registerClass(
        Class.ClassFolder, 
        constructors=(Class.manage_addClassFolderForm,
                      Class.manage_addClassFolder),
        icon='www/classFolder.gif',
        )

    context.registerClass(
        Session.SessionFolder, 
        constructors=(Session.manage_addSessionFolderForm,
                      Session.manage_addSessionFolder),
        icon='www/sessionFolder.gif',
        )

    context.registerClass(
        PersonGroup.MainPersonGroupFolder, 
        constructors=(PersonGroup.manage_addMainPersonGroupFolder,),
        icon='www/personGroupFolder.gif',
        )


    from Products.DBObjects import registerProduct
    registerProduct('ZQuest')
    

# load all the icons automatically
from Globals import package_home, ImageFile
import os
misc_ = {}
path = os.path.join(package_home(globals()), 'www/')

for file in os.listdir(path):
    if file[-3:] == 'gif':
        misc_[file[:-4]] = ImageFile('www/%s' %file, globals())
